# ScriptRunner Connect Managed API for GitLab
Managed API for GitLab is an API Client for GitLab by [Adaptavist](https://www.adaptavist.com/). You can read more about Managed APIs [here](https://docs.adaptavist.com/src/managed-apis).

This is [ScriptRunner Connect](https://scriptrunnerconnect.com) runtime specific version of the Managed API (with `sr-connect` suffix). If you want to use Managed API in any other runtime, have a look at the [runtime agnostic version](https://www.npmjs.com/package/@managed-api/gitlab-v4-core).

# Supported API calls
- [fetch](https://docs.adaptavist.com/src/managed-apis/managed-api-abstractions)
- Branch
    - [createBranch](https://docs.gitlab.com/ee/api/branches.html#create-repository-branch)
    - [deleteBranch](https://docs.gitlab.com/ee/api/branches.html#delete-repository-branch)
    - [deleteMergedBranches](https://docs.gitlab.com/ee/api/branches.html#delete-merged-branches)
    - [getBranch](https://docs.gitlab.com/ee/api/branches.html#get-single-repository-branch)
    - [getBranches](https://docs.gitlab.com/ee/api/branches.html#list-repository-branches)
- Commit
    - [cherryPickCommit](https://docs.gitlab.com/ee/api/commits.html#cherry-pick-a-commit)
    - [createComment](https://docs.gitlab.com/ee/api/commits.html#post-comment-to-commit)
    - [createCommit](https://docs.gitlab.com/ee/api/commits.html#create-a-commit-with-multiple-files-and-actions)
    - [getComments](https://docs.gitlab.com/ee/api/commits.html#get-the-comments-of-a-commit)
    - [getCommit](https://docs.gitlab.com/ee/api/commits.html#get-a-single-commit)
    - [getCommitDiff](https://docs.gitlab.com/ee/api/commits.html#get-the-diff-of-a-commit)
    - [getCommitReferences](https://docs.gitlab.com/ee/api/commits.html#get-references-a-commit-is-pushed-to)
    - [getCommits](https://docs.gitlab.com/ee/api/commits.html#list-repository-commits)
    - [getDiscussions](https://docs.gitlab.com/ee/api/commits.html#get-the-discussions-of-a-commit)
    - [getGPGSignature](https://docs.gitlab.com/ee/user/project/repository/gpg_signed_commits/index.html)
    - [getMergeRequests](https://docs.gitlab.com/ee/api/commits.html#list-merge-requests-associated-with-a-commit)
    - [revertCommit](https://docs.gitlab.com/ee/api/commits.html#revert-a-commit)
    - Status
        - [createBuildStatus](https://docs.gitlab.com/ee/api/commits.html#post-the-build-status-to-a-commit)
        - [getStatuses](https://docs.gitlab.com/ee/api/commits.html#list-the-statuses-of-a-commit)
- Epic
    - [createEpic](https://docs.gitlab.com/ee/api/epics.html#new-epic)
    - [createTodoItem](https://docs.gitlab.com/ee/api/epics.html#create-a-to-do-item)
    - [deleteEpic](https://docs.gitlab.com/ee/api/epics.html#delete-epic)
    - [getEpic](https://docs.gitlab.com/ee/api/epics.html#single-epic)
    - [getEpicsForGroup](https://docs.gitlab.com/ee/api/epics.html#list-epics-for-a-group)
    - [updateEpic](https://docs.gitlab.com/ee/api/epics.html#update-epic)
- Issue
    - [addSpentTimeForIssue](https://docs.gitlab.com/ee/api/issues.html#add-spent-time-for-an-issue)
    - [cloneIssue](https://docs.gitlab.com/ee/api/issues.html#clone-an-issue)
    - [createIssue](https://docs.gitlab.com/ee/api/issues.html#new-issue)
    - [createTodoItem](https://docs.gitlab.com/ee/api/issues.html#create-a-to-do-item)
    - [deleteIssue](https://docs.gitlab.com/ee/api/issues.html#delete-an-issue)
    - [editIssue](https://docs.gitlab.com/ee/api/issues.html#new-issue)
    - [getGroupIssues](https://docs.gitlab.com/ee/api/issues.html#list-group-issues)
    - [getIssue](https://docs.gitlab.com/ee/api/issues.html#single-issue)
    - [getIssues](https://docs.gitlab.com/ee/api/issues.html#list-issues)
    - [getMergeRequestsRelatedToIssue](https://docs.gitlab.com/ee/api/issues.html#list-merge-requests-related-to-issue)
    - [getMergeRequestsThatClosedAnIssue](https://docs.gitlab.com/ee/api/issues.html#list-merge-requests-that-close-a-particular-issue-on-merge)
    - [getParticipants](https://docs.gitlab.com/ee/api/issues.html#participants-on-issues)
    - [getProjectIssue](https://docs.gitlab.com/ee/api/issues.html#single-project-issue)
    - [getProjectIssues](https://docs.gitlab.com/ee/api/issues.html#list-project-issues)
    - [getTimeTrackingStatsForIssue](https://docs.gitlab.com/ee/api/issues.html#get-time-tracking-stats)
    - [getUserAgentDetails](https://docs.gitlab.com/ee/api/issues.html#get-user-agent-details)
    - [moveIssue](https://docs.gitlab.com/ee/api/issues.html#move-an-issue)
    - [promoteToEpic](https://docs.gitlab.com/ee/api/issues.html#promote-an-issue-to-an-epic)
    - [reorderIssue](https://docs.gitlab.com/ee/api/issues.html#reorder-an-issue)
    - [resetSpentTimeForIssue](https://docs.gitlab.com/ee/api/issues.html#reset-spent-time-for-an-issue)
    - [resetTimeEstimateForIssue](https://docs.gitlab.com/ee/api/issues.html#reset-the-time-estimate-for-an-issue)
    - [setTimeEstimateForIssue](https://docs.gitlab.com/ee/api/issues.html#set-a-time-estimate-for-an-issue)
    - [subscribeToIssue](https://docs.gitlab.com/ee/api/issues.html#subscribe-to-an-issue)
    - [unsubscribeFromIssue](https://docs.gitlab.com/ee/api/issues.html#unsubscribe-from-an-issue)
- Link
    - Issue
       - [createLink](https://docs.gitlab.com/ee/api/issue_links.html#create-an-issue-link)
       - [deleteLink](https://docs.gitlab.com/ee/api/issue_links.html#delete-an-issue-link)
       - [getRelations](https://docs.gitlab.com/ee/api/issue_links.html#list-issue-relations)
- Repository
    - [addChangelog](https://docs.gitlab.com/ee/api/repositories.html#add-changelog-data-to-a-changelog-file)
    - [compare](https://docs.gitlab.com/ee/api/repositories.html#compare-branches-tags-or-commits)
    - [generateChangelog](https://docs.gitlab.com/ee/api/repositories.html#generate-changelog-data)
    - [getBlob](https://docs.gitlab.com/ee/api/repositories.html#get-a-blob-from-repository)
    - [getContributors](https://docs.gitlab.com/ee/api/repositories.html#contributors)
    - [getFileArchive](https://docs.gitlab.com/ee/api/repositories.html#get-file-archive)
    - [getRawBlobContent](https://docs.gitlab.com/ee/api/repositories.html#raw-blob-content)
    - [getRepositoryTree](https://docs.gitlab.com/ee/api/repositories.html#list-repository-tree)
    - [mergeBase](https://docs.gitlab.com/ee/api/repositories.html#merge-base)
    - File
        - [createFile](https://docs.gitlab.com/ee/api/commits.html#create-a-commit-with-multiple-files-and-actions)
        - [deleteFile](https://docs.gitlab.com/ee/api/commits.html#create-a-commit-with-multiple-files-and-actions)
        - [getFile](https://docs.gitlab.com/ee/api/repository_files.html#get-file-from-repository)
        - [getFileBlame](https://docs.gitlab.com/ee/api/repository_files.html#get-file-blame-from-repository)
        - [getRawFile](https://docs.gitlab.com/ee/api/repository_files.html#get-raw-file-from-repository)
        - [updateFile](https://docs.gitlab.com/ee/api/repository_files.html#create-new-file-in-repository)

# Constructing Managed API
In ScriptRunner Connect a Managed API is constructed for you, but if you need to construct it manually, here's how you can do it:
```typescript
import { GitlabApi } from '@managed-api/gitlab-v4-sr-connect';

export default async function() {
    const api = new GitlabApi('API_CONNECTION_ID');
}
```

# Contact
Feel free to drop ideas, suggestions or improvements into our [Slack community channel](https://join.slack.com/t/srconnectcommunity/shared_invite/zt-1c6u4gbyq-KJV_e78H0io7yctNZTBc0A).

# Changelog
* 2.3.0
    - Removed non-empty body from HEAD requests.
* 2.2.0
    - `Breaking change:` URL and query string parameters are now URL encoded, meaning if you encoded them explicitly before you have to remove your own encoding, otherwise they will get double encoded.

Copyright Adaptavist 2022 (c) All rights reserved